// ************************************************
// *** NON-MEDIA CLOUDS (but almost so slow!!!) ***
// ************************************************

// Jaime Vives Piqueres, (?)1999.
// jaime@ctav.es
// http://members.xoom.com/jaimevives

// test scene for i_stsky.inc -> storm

#version 3.1;
global_settings{
 max_trace_level 82          // keep higher than the number of planes!
}

#include "colors.inc"
#include "textures.inc"


// the clouds
#include "i_stsky.inc"
#declare dark_color=SkyBlue*.5+White*.5;
#declare light_color=White;
#declare height=8000;
#declare cloud_level=.4;
#declare planes=60;
#declare pdist=30;
#declare ppatt=pigment{bumps}
#declare pturb=.9;
#declare pocta=9;
#declare plamb=3.5;
#declare pomeg=.5;
#declare tdist=30;
#declare sfactor=10000;
#declare dfactor=.9;
#declare border=.1;
#declare fstart=.7;
#declare fend=.8;
object{
 clouds(
  dark_color,         // color for lower parts
  light_color,        // color for upper parts
  height,             // heigth to first layer
  cloud_level,        // level of "cloudiness"(?)
  planes,             // number of planes
  pdist,              // distance between planes
  ppatt,              // pigment pattern
  pturb,              // amount of turbulence
  pocta,              // and its modifiers
  plamb,
  pomeg,
  tdist,              // distance between textures
  sfactor,            // scaling factor
  dfactor,            // darkening factor
  border,             // width of change zone
  fstart,             // filter for lower layer
  fend                // filter for upper layer
 )
 hollow
 no_shadow
 rotate 5*y
}


// "container" sky
sky_sphere{
 pigment{dark_color*dfactor}
}

// the camera looks up for a better effect
// avoid "horizontal" views, the trick is more evident
// (or use a lot of very close planes and be prepared to wait...)
camera{
 location <0,0,-30>
 direction 4*z
 look_at <0,0,0>
 rotate -15*x
}

plane{y,-10
 texture{
  pigment{
   bozo
   turbulence 0.5
   color_map{
    [0.0 DarkGreen]
    [0.4 ForestGreen]
    [0.5 DarkTan]
    [1.0 DarkBrown]
   }
  }
  scale 100
 }
}


// *** ovni (ufo in english, but I like more the spanish word) ***
union{
 sphere{0,1
  scale <1000,100,1000>
  texture{Silver_Metal}
 }
 sphere{0,1
  scale <750,200,750>
  translate -100*y
  texture{Ruby_Glass}
 }
 sphere{0,1
  scale <500,300,500>
  texture{Glass}
  translate 100*y
 }
 light_source{
  <0,-110,0>
  White*10
 }
 light_source{
  <-700,-210,0>
  White
 }
 light_source{
  <700,-210,0>
  White
 }
 light_source{
  <0,-210,700>
  White
 }
 light_source{
  <0,-210,-700>
  White
 }
 scale 4
 rotate 13*x
 translate <0,0,150000>
 rotate <-13,-4,0>
}


light_source{
 <0,0,30000>
 White*.75+Gold*.25+SkyBlue*.125
 rotate -100*x
}